declare module "doubly-linked-list" {
    export interface Node<NodeValueType> {
        value: NodeValueType;
        next: Node<NodeValueType> | null;
        prev: Node<NodeValueType> | null;
    }
    export interface IDoublyLinkedList<NodeValueType> {
        head: Node<NodeValueType> | null;
        tail: Node<NodeValueType> | null;
        size: number;
        addFront: (value: NodeValueType) => void;
        addEnd: (value: NodeValueType) => void;
        removeFront: () => void;
        removeEnd: () => void;
        remove: (value: NodeValueType) => boolean;
        clear: () => void;
        contains: (value: NodeValueType) => boolean;
        forEach: (fn: ForEachFunction<NodeValueType>) => void;
        copyToArray: () => NodeValueType[];
        isEmpty: () => boolean;
        addBefore: (valueBefore: NodeValueType, value: NodeValueType) => boolean;
        addAfter: (valueAfter: NodeValueType, value: NodeValueType) => boolean;
        getNodeByValue: (value: NodeValueType) => Node<NodeValueType> | null;
    }
    export type ForEachFunction<NodeValueType> = (value: NodeValueType, index: number) => void;
    export const createNode: <NodeValueType>(value: NodeValueType) => Node<NodeValueType>;
    export const createDoublyLinkedList: <NodeValueType>() => IDoublyLinkedList<NodeValueType>;
}
declare module "algo-ds" {
    export * from "doubly-linked-list";
}
